
TYPO3.Flow - Bug # 43673

Status: Resolved Priority: Should have
Author: Robert Lemke Category: Session
Created: 2012-12-06 Assigned To: Robert Lemke
Updated: 2012-12-07 Due date:
PHP Version: 5.3
Has patch: No
Complexity: medium
Affected Flow version: Git 1.2 (master)
Subject: Session shutdown might keep destroyed session alive
Description

There's a race condition in multi-server setups regarding the session shutdown: If a session has been destroyed by a second server
between start() / resume() and shutdownObject(), the shutdown method will implicitly revive the session because it writes the session
entry into the storage cache without checking if the session still exists.

Associated revisions
Revision 4dac593a - 2012-12-07 11:06 - Robert Lemke

[BUGFIX] Fix race condition in session shutdown

This protects sessions against being revived through the shutdown
method even though they were destroyed remotely in the meantime.

This patch also contains a small modification and related test to make
sure that incoming session cookies are not blindly sent back to the
user agent in the response. Instead, a clean, new session cookie with
the parameters set in Flow's settings is created.

Change-Id: I09cfd7cbdeb53bfff5345c35592bc88c0fd49fff
Resolves: #43673
Releases: 1.2

History
#1 - 2012-12-06 16:27 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16994

#2 - 2012-12-07 11:06 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16994

#3 - 2012-12-07 15:35 - Robert Lemke
http://review.typo3.org/16994
http://review.typo3.org/16994


- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4dac593a462b55165f0df3a794180fee1381e4f5.
